Imports System.Net
Imports System.IO
Imports System.Text.RegularExpressions
Namespace HexaSoft
    Public Class HexaDB
        Dim strWorldPayTestMode As Boolean = True
        Dim strWorldPayCallBack As String = ""
        Dim strLogPath As String = ""
#Region "Http Get/Post"
        Public Function httpPOST(ByVal URL As String, ByVal Params As String, ByVal cookies As CookieContainer)
            Dim webRequest As HttpWebRequest = webRequest.Create(URL)
            Dim webResponse As Net.HttpWebResponse
            Dim requestStream As Stream
            Dim ContentData As Byte() = System.Text.Encoding.UTF8.GetBytes(Params)
            webRequest.Method = "POST"
            webRequest.ContentType = "application/x-www-form-urlencoded"
            webRequest.ContentLength = ContentData.Length
            webRequest.CookieContainer = cookies
            requestStream = webRequest.GetRequestStream()
            requestStream.Write(ContentData, 0, ContentData.Length)
            webResponse = webRequest.GetResponse()
            Dim reader As System.IO.StreamReader = New IO.StreamReader(webResponse.GetResponseStream())
            requestStream.Close()
            httpPOST = reader.ReadToEnd
        End Function

        Private Function httpGET(ByVal URL As String, ByVal cookies As CookieContainer)
            Dim webRequest As HttpWebRequest = webRequest.Create(URL)
            Dim webResponse As Net.HttpWebResponse
            Dim requestStream As Stream
            webRequest.Method = "GET"
            webRequest.CookieContainer = cookies
            webResponse = webRequest.GetResponse()
            Dim reader As System.IO.StreamReader = New IO.StreamReader(webResponse.GetResponseStream())
            httpGET = reader.ReadToEnd
        End Function

        'Public Function ccAuthorization(ByVal instId As String, _
        '                            ByVal cartID As String, _
        '                            ByVal desc As String, _
        '                            ByVal amount As String, _
        '                            ByVal cardNoInput As String, _
        '                            ByVal name As String, _
        '                            ByVal cardCVV As String, _
        '                            ByVal cardType As String, _
        '                            ByVal cardExpmonth As String, _
        '                            ByVal cardExpyear As String, _
        '                            ByVal address As String, _
        '                            ByVal country As String, _
        '                            ByVal postcode As String, _
        '                            ByVal tel As String, _
        '                            ByVal fax As String, _
        '                            ByVal email As String)
        '    Dim cookies As CookieContainer = New CookieContainer
        '    Dim httpResult As String
        '    Dim httpParam As String
        '    Dim httpURL1 As String = "https://select.worldpay.com/wcc/purchase"
        '    Dim httpURL2 As String = "https://select.worldpay.com/aequitas/card"
        '    Dim httpURLBase As String = "https://select.worldpay.com"
        '    Dim currency = "USD"
        '    Dim strPaymentID As String
        '    Dim strParam As String
        '    Dim oInvoice As New HexaSoft.LookupClass.Invoice
        '    Try
        '        If country = "UK" Then
        '            country = "GB"
        '        End If
        '        httpParam = "instId=" & instId & _
        '                    "&cartId=" & cartID & _
        '                     "&currency=" & currency & _
        '                     "&desc=" & desc & _
        '                     "&amount=" & amount
        '        If (strWorldPayTestMode = True) Then
        '            httpParam = httpParam & "&testMode=100"
        '        End If
        '        httpParam = httpParam & "&MC_callback=" & strWorldPayCallBack
        '        strParam += httpParam & "&"
        '        httpResult = httpPOST(httpURL1, httpParam, cookies)
        '        httpParam = "authCurrency=" & currency
        '        If (cardType = "VISA") Then
        '            httpParam = httpParam & "&op-DPChoose-VISA=op-DPChoose-VISA"
        '        End If
        '        If (cardType = "MC") Then
        '            httpParam = httpParam & "&op-DPChoose-MSCD=op-DPChoose-MSCD"
        '        End If
        '        If (cardType = "AMEX") Then
        '            httpParam = httpParam & "&op-DPChoose-AMEX=op-DPChoose-AMEX"
        '        End If

        '        Dim myMatch As Match = Regex.Match(httpResult, "NAME=PaymentID VALUE=""(\d+)""", RegexOptions.IgnoreCase)

        '        If myMatch Is myMatch.Empty Then
        '            Me.WorldPayLog(httpResult, "WorldPayErrorStep1.txt")
        '            ccAuthorization = "FAIL STEP 1"
        '            Return ccAuthorization
        '        Else
        '            httpParam = httpParam & "&PaymentID=" & myMatch.Groups(1).Value
        '        End If
        '        strPaymentID = myMatch.Groups(1).Value
        '        strParam += httpParam & "&"
        '        httpResult = httpPOST(httpURL1, httpParam, cookies)
        '        myMatch = Regex.Match(httpResult, "content=""0; URL=(.+)"">", RegexOptions.IgnoreCase)
        '        If myMatch Is myMatch.Empty Then
        '            Me.WorldPayLog(httpResult, "WorldPayErrorStep2.txt")
        '            ccAuthorization = "FAIL STEP 2"
        '            Return ccAuthorization
        '        End If
        '        httpResult = httpGET(httpURLBase & myMatch.Groups(1).Value, cookies)
        '        httpParam = "PaymentID=" & strPaymentID & _
        '            "&cardNoInput=" & cardNoInput & _
        '             "&cardNoJS=" & cardNoInput & _
        '             "&name=" & name & _
        '             "&cardCVV=" & cardCVV & _
        '             "&cardExp.day=32" & _
        '             "&cardExp.time=23:59:59" & _
        '             "&cardExp.month=" & cardExpmonth & _
        '             "&cardExp.year=" & cardExpyear & _
        '             "&address=" & address & _
        '             "&country=" & country & _
        '             "&postcode=" & postcode & _
        '             "&tel=" & tel & _
        '             "&fax=" & fax & _
        '             "&email=" & email & _
        '             "&op-PMMakePayment=op-PMMakePayment"
        '        strParam += httpParam
        '        httpResult = httpPOST(httpURL2, httpParam, cookies)
        '        myMatch = Regex.Match(httpResult, "content=""(\d+); URL=(.+)"">", RegexOptions.IgnoreCase)
        '        If Not (myMatch Is myMatch.Empty) Then
        '            System.Threading.Thread.Sleep(5000)
        '            httpResult = httpGET(httpURLBase & myMatch.Groups(2).Value, cookies)
        '            myMatch = Regex.Match(httpResult, "Declined.", RegexOptions.IgnoreCase)
        '            If (myMatch Is myMatch.Empty) Then
        '                myMatch = Regex.Match(httpResult, "content=""(\d+); URL=(.+)"">", RegexOptions.IgnoreCase)
        '                If Not (myMatch Is myMatch.Empty) Then
        '                    System.Threading.Thread.Sleep(5000)
        '                    httpResult = httpGET(httpURLBase & myMatch.Groups(2).Value, cookies)
        '                End If
        '            Else
        '                ccAuthorization = "DECLINED"
        '                Return ccAuthorization
        '            End If
        '        End If
        '        Me.WorldPayLog(strParam)
        '        ccAuthorization = "OK"
        '    Catch e As Exception
        '        ccAuthorization = e.ToString
        '    Finally
        '        cookies = Nothing
        '        httpResult = Nothing
        '        httpParam = Nothing
        '        httpURL1 = Nothing
        '        httpURL2 = Nothing
        '        httpURLBase = Nothing
        '        currency = Nothing
        '        strPaymentID = Nothing
        '        strParam = Nothing
        '        oInvoice = Nothing
        '    End Try
        'End Function
        Private Sub WorldPayLog(ByVal strParam As String)
            Dim oLogFile As New HexaSoft.LookupClass.LOG_FILE
            Try
                oLogFile.Err_Msg = strParam
                oLogFile.DateTime = Now
                oLogFile.Log_Module = "HexaDB"
                oLogFile.Log_Path = "WorldPayInput.txt"
                Me.errLog(oLogFile)
            Catch ex As Exception
            Finally
                oLogFile = Nothing
            End Try
        End Sub
        Private Sub WorldPayLog(ByVal strParam As String, ByVal strPath As String)
            Dim oLogFile As New HexaSoft.LookupClass.LOG_FILE
            Try
                oLogFile.Err_Msg = strParam
                oLogFile.DateTime = Now
                oLogFile.Log_Module = "HexaDB"
                oLogFile.Log_Path = strPath
                Me.errLog(oLogFile)
            Catch ex As Exception
            Finally
                oLogFile = Nothing
            End Try
        End Sub
#End Region
#Region "Log"
        Public Sub errLog(ByVal oLogFile As HexaSoft.LookupClass.LOG_FILE)
            Dim fs As FileStream = New FileStream(strLogPath & oLogFile.Log_Path, FileMode.Append)
            Dim objWriter As StreamWriter = New StreamWriter(fs)
            objWriter.WriteLine(oLogFile.DateTime & "," & oLogFile.Visitor_IP & "," & oLogFile.Log_Module & "," & oLogFile.Err_Msg)
            objWriter.Close()
            fs.Close()
        End Sub

        Public Sub HistoryLog(ByVal oLogFile As HexaSoft.LookupClass.LOG_FILE)
            Dim fs As FileStream = New FileStream(strLogPath & oLogFile.Log_Path, FileMode.Append)
            Dim objWriter As StreamWriter = New StreamWriter(fs)
            objWriter.WriteLine(oLogFile.DateTime & "," & oLogFile.Visitor_IP & "," & oLogFile.Search_Param)
            objWriter.Close()
            fs.Close()
        End Sub
#End Region
    End Class
End Namespace
